<template>
    <div>
      <el-breadcrumb separator=">">
        <el-breadcrumb-item :to="{ path: '/' }">首页</el-breadcrumb-item>
        <el-breadcrumb-item>
          <a href="#">基础信息管理</a>
        </el-breadcrumb-item>
        <el-breadcrumb-item>
          保证金管理
        </el-breadcrumb-item>
      </el-breadcrumb>
      <el-divider></el-divider>
      <!--
        要resetFields起作用，必须配置:model和prop
      -->
      <el-form ref="queryForm" :model="queryModel" inline class="demo-form-inline">
        <el-form-item label="联系电话" prop="phone">
          <el-input type="text" size="mini" v-model="queryModel.phone"></el-input>
        </el-form-item>
        <el-form-item>
          <el-button
            type="primary"
            size="mini"
            icon="ios-search"
            @click="changePage(1)"
            :loading="loading"
          >查询</el-button>&nbsp;
          <el-button
            type="info"
            size="mini"
            style="margin-left: 8px"
            @click="handleReset('queryForm')"
          >重置</el-button>&nbsp;
        </el-form-item>
      </el-form>
      <el-divider></el-divider>
      <!-- <el-row class="button-group">
        <el-button type="primary" size="small" plain icon="el-icon-circle-plus" @click="handleAdd">新增</el-button>
        <el-button
          type="primary"
          size="small"
          plain
          icon="el-icon-remove"
          :disabled="multipleSelection.length==0"
          @click="handleBatchDelete"
        >删除选中项</el-button>
      </el-row> -->
      <el-table
        :data="tableData"
        style="min-height:400px;"
        v-loading="loading"
        stripe
        @sort-change="sortChange"
        @selection-change="handleSelectionChange"
      >
        <el-table-column type="selection" width="55"></el-table-column>
        <el-table-column  prop="realName"  label="姓名" width="180"></el-table-column>
        <el-table-column  prop="phone"  label="联系电话" width="180"></el-table-column>
        <el-table-column  prop="idCard"  label="身份证号" width="180"></el-table-column>
        <el-table-column  prop="payImagesList"  label="凭证">
            <template  slot-scope="{row}">
                <span v-for="(item,index) in row.payImagesList" :key="index" style="margin-left:10px">
                    <el-link :href="item" target="_blank">
                    <el-image style="width: 50px; height: 50px" :src="item" fit="fit"></el-image></el-link>
                </span>
            </template>
        </el-table-column>
        <el-table-column  prop="payStatus"  label="支付审核">
            <template slot-scope="{row}">
                <span v-if="row.payStatus==1" style="color: #F56C6C;">未审核</span>
                <span v-else-if="row.payStatus==2" style="color: #67C23A;">已支付</span>
          </template>
        </el-table-column>
        
        <el-table-column label="操作"  width="180">
          <template slot-scope="{row}" >
            <el-link v-if="row.payStatus != 2" type="success" @click="handleChecked(row)">审核</el-link>
            <!-- <el-link type="primary" @click="handleEdit(row)">编辑-</el-link>
            <el-link type="danger" @click="handleDelete(row)">删除</el-link> -->
          </template>
        </el-table-column>
      </el-table>
      <el-pagination
        :current-page.sync="pageIndex"
        :total="totalElements"
        :page-sizes="pageSizeList"
        @current-change="changePage"
        @size-change="pageSizeChange"
        layout="total, sizes, prev, pager, next, jumper"
      ></el-pagination>
      <deposit-detail
        v-if="showModal"
        ref="userDetail"
        :businessKey="businessKey"
        :title="modalTitle"
        @close="onDetailModalClose"
      ></deposit-detail>
    </div>
  </template>
  <script>
  import Constant from "@/constant";
  import depositApi from "@/api/base/deposit";
  import depositDetail from "./deposit-detail";
  
  export default {
    name: 'baseDepositList',
    data() {
      var self = this;
  
      return {
        queryModel: {
          realName: "",
          phone:"",
          idCard:"",
          status:"",
        },
        loading: false,
        tableData: [],
        pageIndex: 1,
        pageSize: 10,
        totalPages: 0,
        totalElements: 0,
        field: "",
        direction: "",
        pageSizeList: [10, 20, 30],
        multipleSelection: [],
        modalTitle: "",      
        businessKey: "",
        showModal: false,
      };
    },
    methods: {
      changePage(pageIndex,exportFlag) {
        var self = this;
  
        console.log(pageIndex);
  
        self.pageIndex = pageIndex;
        var formData = new FormData();
  
        formData.append("pageIndex", self.pageIndex);
        
        if(exportFlag!=null){
            formData.append("exportFlag", exportFlag);
            formData.append("pageSize", 10000);
        }
        else{
            formData.append("pageSize", self.pageSize);
        }
        formData.append("realName", self.queryModel.realName);
        formData.append("phone", self.queryModel.phone);
        formData.append("idCard", self.queryModel.idCard);
        formData.append("status", self.queryModel.status);
  
        self.loading = true;
  
        depositApi.pageList(formData).then(function(response) {
          self.loading = false;
            var jsonData = response.data;
            if(jsonData.result) {
                if(exportFlag){
                    //导出
                    self.$message({
                        showClose: true,
                        type: "success",
                        message: `报表已生成，<a href="${jsonData.data}">请点击链接下载</a>`,
                        dangerouslyUseHTMLString: true,
                        duration: 30000
                    });
                }
                else{
                    //分页查看
                    var page = jsonData.data;

                    self.tableData = page.data;
                    self.totalPages = page.totalPages;
                    self.totalElements = page.recordsTotal;
                }
            }
            else{
                self.$message.warning(jsonData.message);
            }
        }).catch((error)=>{
          self.loading = false;
        });
      },
      pageSizeChange(pageSize) {
        this.pageSize = pageSize;
      },
      sortChange(data) {
        this.field = data.column.field;
        this.direction = data.order == "ascending" ? "asc" : "desc";
  
        this.changePage(this.pageIndex);
      },
      handleSelectionChange(val) {
        this.multipleSelection = val;
      },
      handleReset(name) {
        this.$refs[name].resetFields();
      },
      handleAdd() {
        var self = this;
        
        self.modalTitle = "新增用户";
        self.businessKey = "";
        self.showModal = true;
      },
      handleEdit(record) {
        var self = this;
        
        self.modalTitle = "编辑用户";
        self.businessKey = record.id;
        self.showModal = true;
      },
      handleChecked(record) {
        var self = this;
  
        this.$confirm("是否确认审核通过？", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
            depositApi.checked(record.id).then(function(response) {
            var jsonData = response.data;
  
            if (jsonData.result) {
              self.changePage(self.pageIndex);
  
              self.$message({
                type: "success",
                message: "审核成功!"
              });
            }
          });
        });
      },
      handleDelete(record) {
        var self = this;
  
        this.$confirm("是否确认删除？", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
            depositApi.remove(record.id).then(function(response) {
            var jsonData = response.data;
  
            if (jsonData.result) {
              // var index = self.tableData.indexOf(record);
              // self.tableData.splice(index, 1);
              self.changePage(self.pageIndex);
  
              self.$message({
                type: "success",
                message: "删除成功!"
              });
            }
          });
        });
      },
      handleBatchDelete() {
        var self = this;
  
        var idList = this.multipleSelection.map(record => {
          return record.id;
        });
  
        this.$confirm("是否确认删除选中项？", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
            depositApi.batchRemove(idList).then(function(response) {
            var jsonData = response.data;
  
            if (jsonData.result) {
              self.changePage(self.pageIndex);
  
              self.$message({
                type: "success",
                message: "删除成功!"
              });
            }
          });
        });
      },
      handleCheck(record){
        var self = this;
  
        this.$confirm("是否确认审核？", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
            depositApi.check(record.id).then(function(response) {
            var jsonData = response.data;

            if (jsonData.result) {
              // var index = self.tableData.indexOf(record);
              // self.tableData.splice(index, 1);
              self.changePage(self.pageIndex);

              self.$message({
                type: "success",
                message: "审核成功!"
              });
            }
          });
        });
      },
      onDetailModalClose(refreshed) {
          this.showModal = false;
  
          if(refreshed) {
          this.changePage(this.pageIndex);
          }
      },
    },
    mounted: function() {
      var self = this;
      this.changePage(1);
    },
    components: {
        "deposit-detail":depositDetail
    }
  };
  </script>
  <style lang="scss" scoped>
  .el-breadcrumb {
    margin: 10px;
    line-height: 20px;
  }
  
  .el-divider {
    margin: 5px 0;
  }
  
  .demo-form-inline {
    margin-left: 10px;
    text-align: left;
  }
  
  .button-group {
    padding: 10px;
    text-align: left;
  }
  </style>